> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.beehiiv.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.beehiiv.com/_mcp/server.

# Bulk create subscription <Badge intent="info" minimal outlined>OAuth Scope: subscriptions:write</Badge>

POST https://api.beehiiv.com/v2/publications/{publicationId}/bulk_subscriptions
Content-Type: application/json

Create new subscriptions for a publication.

Reference: https://developers.beehiiv.com/api-reference/bulk-subscriptions/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `publicationId` (string, required) — The prefixed ID of the publication object

### Body (application/json)

This endpoint expects an object.

- `subscriptions` (list of SubscriptionRequest, required)

## Response

### 200

Subscriptions created

- `message` (string, required) — The result of the create request
- `import_id` (string, required) — The database ID of the import object created from the Bulk Subscription Create request

## Errors

### 400 Bad Request Error

Bad Request

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 401 Unauthorized Error

Unauthorized. The API key or OAuth access token is missing, invalid, or expired.

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 404 Not Found Error

Resource Not Found

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 429 Too Many Requests Error

Rate Limit Exceeded

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 500 Internal Server Error

Internal Server Error

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

## Types

### SubscriptionRequest

- `email` (string, required) — The email address of the subscription.
- `reactivate_existing` (boolean, optional, default: false) — Whether or not to reactivate the subscription if they have already unsubscribed. This option should be used only if the subscriber is knowingly resubscribing.
- `send_welcome_email` (boolean, optional, default: false)
- `utm_source` (string, optional) — The source of the subscription.
- `utm_medium` (string, optional) — The medium of the subscription
- `utm_campaign` (string, optional) — The acquisition campaign of the subscription
- `utm_term` (string, optional) — The acquisition term; typically the keyword or search term
- `utm_content` (string, optional) — The acquisition content; typically used for A/B testing or ad variations
- `referring_site` (string, optional) — The website that the subscriber was referred from
- `referral_code` (string, optional) — This should be a subscribers referral_code. This gives referral credit for the new subscription.
- `custom_fields` (list of CustomFieldValue, optional) — The custom fields must already exist for the publication. Any new custom fields here will be discarded.
- `double_opt_override` (string, optional) — Override the publication's default double opt-in settings for this subscription. Possible values are: - "on" — The subscriber will receive a double opt-in confirmation email and will need to confirm their subscription prior to being marked as active. - "off" — The subscriber will be marked as active immediately and will not receive a double opt-in confirmation email. - "not_set" — The publication's default double opt-in settings will be applied to this subscription.
- `tier` (enum, optional) — The tier for this subscription.
  - Allowed values: `free`, `premium`
- `premium_tiers` (list of string, optional) — An array of premium tier names to assign to this subscription. When provided, the subscription will be assigned to premium tiers matching these names. Can be combined with `premium_tier_ids` to include tiers from both (duplicates are removed). Takes precedence over the `tier` parameter.
- `premium_tier_ids` (list of string, optional) — An array of premium tier IDs to assign to this subscription. When provided, the subscription will be assigned to these specific premium tiers. Can be combined with `premium_tiers` to include tiers from both (duplicates are removed). Takes precedence over the `tier` parameter.
- `stripe_customer_id` (string, optional) — The Stripe customer ID for this subscription.
- `automation_ids` (list of string, optional) — Enroll the subscriber into automations after their subscription has been created. Requires the automations to have an active *Add by API* trigger.
- `newsletter_list_ids` (list of string, optional) — An array of newsletter list prefixed IDs to subscribe the new subscription to. The newsletter lists must belong to the same publication.
- `skip_newsletter_list_auto_subscribe` (boolean, optional) — When true, the subscriber will not be auto-subscribed to newsletter lists configured with auto-subscribe. Defaults to false.
- `complimentary_gift_id` (string, optional) — The prefixed ID of a complimentary access object to apply to this subscription. The complimentary access must belong to the same publication.

### ErrorDetail

- `message` (string, required)
- `code` (string, required)

### CustomFieldValue

The object required for setting custom field values on a subscription

- `name` (string, optional) — The name of the existing custom field
- `value` (CustomFieldDataType, optional) — The value stored for the subscription

### CustomFieldDataType

- string
- double
- boolean
- list of string

## Examples

**Request**

```json
{
  "subscriptions": [
    {
      "email": "bruce.wayne@wayneenterprise.com",
      "reactivate_existing": false,
      "send_welcome_email": false,
      "custom_fields": [
        {
          "name": "Favorite Color",
          "value": "Red"
        }
      ]
    },
    {
      "email": "lucius.fox@wayneenterprise.com",
      "reactivate_existing": false,
      "send_welcome_email": false,
      "custom_fields": [
        {
          "name": "Favorite Color",
          "value": "Blue"
        }
      ]
    }
  ]
}
```

**Response**

```json
{
  "message": "Bulk Subscription Create Request Sent.",
  "import_id": "00000000-0000-0000-0000-000000000000"
}
```

**SDK Code**

```python
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions"

payload = { "subscriptions": [
        {
            "email": "bruce.wayne@wayneenterprise.com",
            "reactivate_existing": False,
            "send_welcome_email": False,
            "custom_fields": [
                {
                    "name": "Favorite Color",
                    "value": "Red"
                }
            ]
        },
        {
            "email": "lucius.fox@wayneenterprise.com",
            "reactivate_existing": False,
            "send_welcome_email": False,
            "custom_fields": [
                {
                    "name": "Favorite Color",
                    "value": "Blue"
                }
            ]
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"subscriptions":[{"email":"bruce.wayne@wayneenterprise.com","reactivate_existing":false,"send_welcome_email":false,"custom_fields":[{"name":"Favorite Color","value":"Red"}]},{"email":"lucius.fox@wayneenterprise.com","reactivate_existing":false,"send_welcome_email":false,"custom_fields":[{"name":"Favorite Color","value":"Blue"}]}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions"

	payload := strings.NewReader("{\n  \"subscriptions\": [\n    {\n      \"email\": \"bruce.wayne@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Red\"\n        }\n      ]\n    },\n    {\n      \"email\": \"lucius.fox@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Blue\"\n        }\n      ]\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"subscriptions\": [\n    {\n      \"email\": \"bruce.wayne@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Red\"\n        }\n      ]\n    },\n    {\n      \"email\": \"lucius.fox@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Blue\"\n        }\n      ]\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"subscriptions\": [\n    {\n      \"email\": \"bruce.wayne@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Red\"\n        }\n      ]\n    },\n    {\n      \"email\": \"lucius.fox@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Blue\"\n        }\n      ]\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions', [
  'body' => '{
  "subscriptions": [
    {
      "email": "bruce.wayne@wayneenterprise.com",
      "reactivate_existing": false,
      "send_welcome_email": false,
      "custom_fields": [
        {
          "name": "Favorite Color",
          "value": "Red"
        }
      ]
    },
    {
      "email": "lucius.fox@wayneenterprise.com",
      "reactivate_existing": false,
      "send_welcome_email": false,
      "custom_fields": [
        {
          "name": "Favorite Color",
          "value": "Blue"
        }
      ]
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"subscriptions\": [\n    {\n      \"email\": \"bruce.wayne@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Red\"\n        }\n      ]\n    },\n    {\n      \"email\": \"lucius.fox@wayneenterprise.com\",\n      \"reactivate_existing\": false,\n      \"send_welcome_email\": false,\n      \"custom_fields\": [\n        {\n          \"name\": \"Favorite Color\",\n          \"value\": \"Blue\"\n        }\n      ]\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["subscriptions": [
    [
      "email": "bruce.wayne@wayneenterprise.com",
      "reactivate_existing": false,
      "send_welcome_email": false,
      "custom_fields": [
        [
          "name": "Favorite Color",
          "value": "Red"
        ]
      ]
    ],
    [
      "email": "lucius.fox@wayneenterprise.com",
      "reactivate_existing": false,
      "send_welcome_email": false,
      "custom_fields": [
        [
          "name": "Favorite Color",
          "value": "Blue"
        ]
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/bulk_subscriptions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```